import { r as registerInstance, h, H as Host } from './index-b6f10a81.js';
import './index-ec7dc2ad.js';
import './state-tunnel-04c0b67a.js';
import './data-model-bb5789f5.js';
import './BaseField-d94c5b14.js';
import './FieldModelGenerator-6ec60042.js';
import './date-b270be76.js';
import './index-94c1d7bf.js';
import { T as TableConfig } from './table-config-c0c15e50.js';
import './string-2d991277.js';
import './membership-config-856f6e58.js';
import './User-e14f1ece.js';
import './_commonjsHelpers-63c253cd.js';
import './index-fd2b14ae.js';
import { i as injectNotifier } from './index-213e8cee.js';
import './kimlikApi-81acfec6.js';
import './data-transfer-field-1ad95e08.js';
import './filter-cbaa3d7d.js';
import './cookie-d9098150.js';
import './moment-6f6ab70c.js';
import { C as CalendarUtils } from './calendar-a511fee1.js';
import { D as DvnAppViewConfig } from './view-config-3ab16b28.js';
import './attachment-8831acff.js';
import { c as createMentornityApiInstance } from './instance-f50cdfd9.js';
import { g as getSessionDetails, m as mentornityApiEndpoint } from './session-78c3c986.js';
import { D as DetailViewConfig } from './detail-view-config-6178fa2c.js';
import './index-47482faa.js';
import { b as convertFieldsToFieldReferences, d as getPairConfigOptionsFromOrganisationConfig, e as commonUserInfoFields, c as convertMentornityFieldToDevingenField, g as getFieldsToShow, M as MentornityBridgeApi } from './common-wrapper-util-3e52e361.js';
import { P as PairConfig } from './pair-config-6cadad1f.js';
import { p as pairConfig } from './pair-config-ff3c76f5.js';

class AtamaMemberPairsSelectionViewConfig extends DvnAppViewConfig {
  static decode(json) {
    const model = Object.assign(Object.create(AtamaMemberPairsSelectionViewConfig.prototype), json);
    model.table = PairConfig.decode(model.table);
    return model;
  }
}

const en = {
  selectionView: {
    cancel: 'Cancel',
    fetchConfigurationError: 'Getting configuration failed.',
    fetchSelectionListError: 'Getting selection list failed.',
    fetchSentRequestListError: 'Getting sent requests failed.',
    listToSelect: 'LIST TO SELECT',
    maxLimitMessage: 'You can send max {selectionLimit} requests at a time.',
    noItemToSelect: 'There are no users to select.',
    noItemMatchesFilter: 'No users match your search.',
    noSentRequests: 'You haven\'t sent any requests.',
    pairRequestIsSent: 'Request is sent.',
    searchPlaceholder: 'Search by any info',
    seeDetails: 'See Details',
    select: 'Select',
    sendMessage: 'Message',
    sentRequests: 'SENT REQUESTS',
    sentOnDateFormat: 'DD MMM YYYY, HH:mm',
    selectionConfirmationDialogTitle: 'Are you sure to select this user?',
    selectionConfirmationDialogMessageForApproval: 'The user will receive a notification and the process will start after the user approves the request. Requests can only be canceled by the program administration.',
    selectionConfirmationDialogMessage: 'The user will receive a notification and the process will start immediately. Pairs can only be canceled by the program administration.',
    statusLabels: {
      accepted: 'Accepted',
      canceled: 'Canceled',
      completed: 'Completed',
      rejected: 'Rejected',
      requested: 'Requested',
    },
    yes: 'Yes',
  },
};
const tr = {
  selectionView: {
    cancel: 'Vazgeç',
    fetchConfigurationError: 'Ayarlar alınırken hata oluştu.',
    fetchSelectionListError: 'Seçim listesi alınırken hata oluştu.',
    fetchSentRequestListError: 'Gönderilen istek listesi alınırken hata oluştu.',
    listToSelect: 'Seçim Listesi',
    maxLimitMessage: 'En fazla {selectionLimit} istek gönderebilirsiniz.',
    noItemToSelect: 'Seçecek kullanıcı bulunamadı.',
    noItemMatchesFilter: 'Arama ölçütünüzle eşleşen kullanıcı bulunamadı.',
    noSentRequests: 'Henüz bir istek göndermediniz.',
    pairRequestIsSent: 'İstek gönderildi.',
    searchPlaceholder: 'Kullanıcı ara',
    seeDetails: 'Detaylar',
    select: 'Seç',
    sendMessage: 'Mesaj',
    sentRequests: 'Gönderilen İstekler',
    sentOnDateFormat: 'DD MMM YYYY, HH:mm',
    selectionConfirmationDialogTitle: 'Bu kullanıcıyı seçmek istediğinize emin misiniz?',
    selectionConfirmationDialogMessageForApproval: 'İstek gönderildikten sonra kullanıcıya bildirim gönderilecek ve süreç, kullanıcı isteği kabul ettikten sonra başlayacak. İstekler sadece yönetim tarafından iptal edilebilir.',
    selectionConfirmationDialogMessage: 'Kullanıcıya bildirim gönderilecek ve süreç anında başlayacak. Süreç sadece yönetim kontrolünde bitirilebilir.',
    statusLabels: {
      accepted: 'Onaylandı',
      canceled: 'İptal Edildi',
      completed: 'Sonlandırıldı',
      rejected: 'Reddedildi',
      requested: 'Gönderildi',
    },
    yes: 'Evet',
  },
};

function getPairSelectionParameters() {
  const { context } = getSessionDetails();
  // user is mentee, so the view config should say that the 'subscribed' is viewing the 'subscriber'
  return {
    memberToViewRefFieldId: 'subscribed',
    userRefFieldValue: context.userId,
    userRefFieldId: 'subscriber',
    viewIdToNavigateOnSelectionDone: 'pair-selection-done-page'
  };
}
function getPairSelectionViewConfig(language, config) {
  if (!config) {
    return null;
  }
  const i18n = language === 'tr' ? tr : en;
  const profileFieldVisibility = config.profileFieldVisibilities.mentor;
  const defaultUserFields = ['title', 'bio', 'skills']
    .filter(id => profileFieldVisibility[id])
    .map(id => ({
    fieldId: id,
    lines: id === 'skills' ? 5 : 1,
  }));
  const infoCardFields = [...defaultUserFields, ...convertFieldsToFieldReferences(config.metadatas.mentor)]
    .filter(field => !['fullName', 'imageUrl'].includes(field.fieldId))
    .map(fieldConfig => (Object.assign(Object.assign({}, fieldConfig), { lines: config.metadatas.mentor.find(f => f.id === fieldConfig.fieldId).linesMax || 1 })));
  return AtamaMemberPairsSelectionViewConfig.decode({
    _id: 'pair-select-page',
    ui: {
      i18n: i18n.selectionView,
      main: {
        cardViewConfig: {
          header: {
            cover: {
              //   aspectRatio: 16 / 9,
              //   fieldId: 'imageUrl',
              size: 100,
            },
            image: {
              fieldId: 'imageUrl',
              size: 72,
            },
            title: {
              fieldId: 'fullName',
            },
          },
          body: {
            fields: infoCardFields,
          },
        },
      },
    },
    params: {},
    table: pairConfig(config, undefined, getPairConfigOptionsFromOrganisationConfig(config)),
  });
}
function getUserDetailDialogParams(actionData) {
  return {
    itemId: actionData.params.item._id,
  };
}
function getUserDetailDialogViewConfig(mentornityCookieContext, config) {
  if (!config) {
    return undefined;
  }
  const { organisationId, role } = mentornityCookieContext;
  const fields = getFieldsToShow(role, config);
  const membershipFields = [...commonUserInfoFields, ...fields].map(convertMentornityFieldToDevingenField);
  const profileFieldVisibility = config.profileFieldVisibilities.mentor;
  const defaultUserFields = ['title', 'bio', 'skills']
    .filter(id => profileFieldVisibility[id])
    .map(id => ({ fieldId: id }));
  const detailCardFields = [...defaultUserFields, ...convertFieldsToFieldReferences(config.metadatas.mentor)]
    .filter(field => !['fullName', 'imageUrl'].includes(field.fieldId));
  return DetailViewConfig.decode({
    table: TableConfig.decode({
      base: organisationId,
      name: 'mentors',
    }),
    ui: {
      fields: membershipFields,
      cardConfig: {
        header: {
          title: {
            fieldId: 'fullName',
          },
        },
        body: {
          fields: detailCardFields,
        }
      }
    },
  });
}

const MentornityPairsOverviewWrapper = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
  }
  onAction(event) {
    const action = event.detail;
    if (action.name === 'send-message') {
      // called when mentor clicks the "Send Message" button from the mentor selection card
      window.dispatchEvent(new CustomEvent('dvn.atama-pairs.send-message', {
        detail: {
          user: action.params.item,
        }
      }));
    }
    if (action.name === 'view-details') {
      // called when mentor clicks the "Send Message" button from the mentor selection card
      this.viewUserDetailDialogActionData = action;
    }
  }
  componentWillLoad() {
    const { language, timeZone } = this;
    CalendarUtils.setLocale(language);
    CalendarUtils.setTimeZone(timeZone);
    const { context, headers } = getSessionDetails();
    this.mentornityBridgeApi = new MentornityBridgeApi(mentornityApiEndpoint, context, headers);
    createMentornityApiInstance(mentornityApiEndpoint, headers)
      .getOrganisationConfig(context.organisationId).then((response) => this.organisationConfig = response);
  }
  render() {
    const { context } = getSessionDetails();
    const { language, mentornityBridgeApi, organisationConfig, viewUserDetailDialogActionData } = this;
    const pairSelectionViewConfig = getPairSelectionViewConfig(language, organisationConfig);
    if (!pairSelectionViewConfig) {
      return (h("div", { class: "d-flex justify-content-center pt-3" }, h("dvn-progress", { indefinite: true })));
    }
    return (h(Host, { style: { display: 'block' } }, h("mentornity-root-wrapper", null, h("dvn-app-view-atama-member-pair-selection-view", { apiAtama: mentornityBridgeApi, apiUye: mentornityBridgeApi, notifier: this.notifier, params: getPairSelectionParameters(), view: pairSelectionViewConfig }), viewUserDetailDialogActionData &&
      h("dvn-dialog", { raw: true, shown: true, onDismiss: () => this.viewUserDetailDialogActionData = undefined }, h("dvn-app-view-detail-view", { apiData: mentornityBridgeApi, id: "user-page", params: getUserDetailDialogParams(viewUserDetailDialogActionData), view: getUserDetailDialogViewConfig(context, organisationConfig) })))));
  }
};
injectNotifier(MentornityPairsOverviewWrapper);

export { MentornityPairsOverviewWrapper as mentornity_pair_selection_wrapper };
